Imports System.Data.Entity
Imports DomainClasses

Namespace DataAccess
  Public Class ScreencastContext
	  Inherits DbContext

	Public Property Screencasts As DbSet(Of Screencast)

	Public Property Topics As DbSet(Of Topic)

	Public Property Authors As DbSet(Of Author)

	Public Property ScreenCastSections As DbSet(Of ScreenCastSection)
  End Class

  Public Class MyInitializer
        Inherits DropCreateDatabaseAlways(Of ScreencastContext)

	Protected Overrides Sub Seed(ByVal context As ScreencastContext)
	  Dim topicList = New List(Of Topic) From {
		  New Topic With {.Name = "Web Dev"},
		  New Topic With {.Name = "Data Dev"},
		  New Topic With {.Name = "Client Dev"},
		  New Topic With {.Name = "Service Dev"},
		  New Topic With {.Name = "UX"}}
	  topicList.ForEach(Function(t) context.Topics.Add(t))
	  context.Authors.Add(New Author With {.Name = "Julie Lerman"})
	  context.Authors.Add(New Author With {.Name = "Sampson Giantpuppy"})
	  context.Authors.Add(New Author With {.Name = "Mike Campbell"})
	  MyBase.Seed(context)
	End Sub
  End Class
End Namespace
