Imports System.Data.Entity
Imports System.Web.Mvc
Imports DomainClasses
Imports DataAccess

Namespace MvcApp.Controllers
	Public Class ScreencastMVCController
		Inherits Controller

		Private db As New ScreencastContext

		'
		' GET: /ScreencastMVC/

		Public Function Index() As ActionResult
			Dim screencasts = db.Screencasts.Include(Function(s) s.Topic)
			Return View(screencasts.ToList)
		End Function

		'
		' GET: /ScreencastMVC/Details/5

		Public Function Details(Optional ByVal id As Integer = 0) As ActionResult
			Dim screencast As Screencast = db.Screencasts.Find(id)
			If screencast Is Nothing Then
				Return HttpNotFound()
			End If
			Return View(screencast)
		End Function

		'
		' GET: /ScreencastMVC/Create

		Public Function Create() As ActionResult
			ViewBag.TopicId = New SelectList(db.Topics, "Id", "Name")
			Return View()
		End Function

		'
		' POST: /ScreencastMVC/Create

		<HttpPost>
		Public Function Create(ByVal screencast As Screencast) As ActionResult
			If ModelState.IsValid Then
				db.Screencasts.Add(screencast)
				db.SaveChanges()
				Return RedirectToAction("Index")
			End If

			ViewBag.TopicId = New SelectList(db.Topics, "Id", "Name", screencast.TopicId)
			Return View(screencast)
		End Function

		'
		' GET: /ScreencastMVC/Edit/5

		Public Function Edit(Optional ByVal id As Integer = 0) As ActionResult
			Dim screencast As Screencast = db.Screencasts.Find(id)
			If screencast Is Nothing Then
				Return HttpNotFound()
			End If
			ViewBag.TopicId = New SelectList(db.Topics, "Id", "Name", screencast.TopicId)
			Return View(screencast)
		End Function

		'
		' POST: /ScreencastMVC/Edit/5

		<HttpPost>
		Public Function Edit(ByVal screencast As Screencast) As ActionResult
			If ModelState.IsValid Then
				db.Entry(screencast).State = EntityState.Modified
				db.SaveChanges()
				Return RedirectToAction("Index")
			End If
			ViewBag.TopicId = New SelectList(db.Topics, "Id", "Name", screencast.TopicId)
			Return View(screencast)
		End Function

		'
		' GET: /ScreencastMVC/Delete/5

		Public Function Delete(Optional ByVal id As Integer = 0) As ActionResult
			Dim screencast As Screencast = db.Screencasts.Find(id)
			If screencast Is Nothing Then
				Return HttpNotFound()
			End If
			Return View(screencast)
		End Function

		'
		' POST: /ScreencastMVC/Delete/5

		<HttpPost, ActionName("Delete")>
		Public Function DeleteConfirmed(ByVal id As Integer) As ActionResult
			Dim screencast As Screencast = db.Screencasts.Find(id)
			db.Screencasts.Remove(screencast)
			db.SaveChanges()
			Return RedirectToAction("Index")
		End Function

		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			db.Dispose()
			MyBase.Dispose(disposing)
		End Sub
	End Class
End Namespace
