Imports System.Text
Imports System.Threading.Tasks
Imports DataAccess
Imports DomainClasses

Namespace Repositories
  Public Class StupidSimpleRepository
	Public Function GetTopicList() As List(Of Topic)
	  Using context = New ScreencastContext
		Return context.Topics.ToList
	  End Using
	End Function

	Public Sub SaveNewScreencast(ByVal screencast As Screencast)
	  Using context = New ScreencastContext
		context.Screencasts.Add(screencast)
		context.SaveChanges()
	  End Using
	End Sub

	Public Sub SaveNewScreencastWithTopic(ByVal screencast As Screencast, ByVal topic As Topic)
	  Using context = New ScreencastContext
		context.Screencasts.Add(screencast)
		' context.Topics.Attach(topic);
		screencast.Topic = topic
		context.SaveChanges()
	  End Using
	End Sub

Public Sub SaveNewScreencastWithTopicId(ByVal screencast As Screencast, ByVal topicId As Integer)
  If topicId > 0 Then
	screencast.Topic = Nothing
	screencast.TopicId = topicId
  End If
  Using context = New ScreencastContext
	context.Screencasts.Add(screencast)
	context.SaveChanges()
  End Using
End Sub

Public Sub SaveNewScreenCastGraph(ByVal screencast As Screencast)
  Using context = New ScreencastContext
	context.Screencasts.Add(screencast)
	screencast.Sections.Where(Function(s) s.Id>0).ToList.ForEach(Function(s) context.Entry(s).State=EntityState.Modified)
	context.SaveChanges()
  End Using
End Sub
  End Class
End Namespace
